<!--version: 3, 店铺选择弹窗-->
<!--版本更新内容：添加prop属性，修复多选-->

<template>
  <el-dialog :title="title" :visible="show" width="60%" top="2vh" @open="open" @close="close"
             :append-to-body="true">
    <el-form  size="small" :inline="true" label-width="8em">
      <el-form-item label="店铺名称:">
        <el-input v-model="searchForm.name" clearable></el-input>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" @click="onSearch()" icon="el-icon-search">搜索</el-button>
      </el-form-item>
    </el-form>

    <el-table
      ref="multipleTable"
      :data="tableData"
      v-loading="loadTable"
      @row-click="changeSelection"
      @row-dblclick="select"
      @select-all="selectionAll"
      @select="changeSelection"
      highlight-current-row
    >
      <el-table-column align="center" type="selection" v-if="multiple"></el-table-column>
      <el-table-column label="#" type="index" align="center"></el-table-column>
      <el-table-column label="店铺图片" align="center" prop="picture" width="100">
        <template slot-scope="scope">
          <image-preview :src="scope.row.picture" :width="50" :height="50"/>
        </template>
      </el-table-column>
      <el-table-column label="店铺名称" align="center" prop="name" width="200"></el-table-column>
      <el-table-column label="店铺地址" align="center">
        <template slot-scope="d">
          {{d.row.province}}{{d.row.city}}{{d.row.county}}{{d.row.address}}
        </template>
      </el-table-column>
    </el-table>
    <pagination
      :limit.sync="searchForm.pageSize"
      :page.sync="searchForm.pageNum"
      :total="total"
      @pagination="searchList">
    </pagination>
    <template #footer>
      <el-button type="primary" @click="submit()">确定</el-button>
    </template>
  </el-dialog>
</template>

<script>
import {clone} from "@/utils";
import { listStore } from '@/api/rl/store'
import { mapGetters } from 'vuex'
import { UserType } from '@/utils/constants'
// import { mchListStore } from '@/api/mch/store'

export default {
  name: "StoreDialog",
  props: {
    // 标题
    title: {
      type: String,
      default: '选择店铺'
    },
    value: {
      type: [String, Number, Array],
      default: null,
    },
    multiple: {
      type: Boolean,
      default: false,
    },
    show: {
      type: Boolean,
      default: false
    },
    query: {
      type: Object,
      default: () => ({})
    },
    initSelect: {
      type: Array,
      default: null,
    },
    prop: {
      type: String,
      default: 'id'
    }
  },
  data() {
    return {
      loadTable: false,
      tableData: [],
      searchForm: {},
      total: 0,
      row: null,
      selected: [],
    }
  },
  computed: {
    ...mapGetters(['userType'])
  },
  methods: {
    // 获取数据列表
    searchList() {
      this.loadTable = true;

      if (this.userType === UserType.APP) {
        // mchListStore().then(response => {
        //   this.tableData = response.rows;
        //   this.total = response.total;
        //   // 刷新表格状态
        //   this.$nextTick(()=>{
        //     this.refreshTableSelection();
        //   })
        // }).finally(() =>{
        //   this.loadTable = false;
        // })
      } else {
        listStore.then(response => {
          this.tableData = response.rows;
          this.total = response.total;
          // 刷新表格状态
          this.$nextTick(()=>{
            this.refreshTableSelection();
          })
        }).finally(() =>{
          this.loadTable = false;
        })
      }
    },
    // 打开时
    open() {
      this.searchForm = {
        pageNum: 1,
        pageSize: 10,
        ...this.query,
      }

      if (this.initSelect) {
        this.selected = clone(this.initSelect);
      } else {
        this.selected = [];
      }

      this.searchList();
    },
    // 刷新表格的选中状态
    refreshTableSelection() {
      if(this.multiple){
        this.tableData.forEach(item => {
          if (this.selected.map(j => j[this.prop]).includes(item[this.prop])) {
            this.$refs.multipleTable.toggleRowSelection(item, true);
          } else {
            this.$refs.multipleTable.toggleRowSelection(item, false);
          }
        });
      }
    },
    // 全选
    selectionAll(val){
      let flag = val.length > 0;
      this.tableData.forEach(item => {
        if (flag && !this.selected.map(i => i[this.prop]).includes(item[this.prop])){
          this.selected.push(item);
        } else if (!flag && this.selected.map(i => i[this.prop]).includes(item[this.prop])){
          this.selected = this.selected.filter(i => i[this.prop] !== item[this.prop]);
        }
      })
    },
    // 确认选中
    submit() {
      if (this.multiple) {
        this.$emit('select', this.selected);
      } else {
        this.select(this.row);
      }
    },
    // 更换某一行的选中状态
    changeSelection(row){
      if(this.multiple){
        if (this.selected.map(i => i[this.prop]).includes(row[this.prop])){
          this.$refs.multipleTable.toggleRowSelection(row, false);
          this.selected = this.selected.filter(i => i[this.prop] !== row[this.prop]);
        }else {
          this.$refs.multipleTable.toggleRowSelection(row, true);
          this.selected.push(row);
        }
      } else {
        this.row = row;
      }
    },
    // 点击搜索
    onSearch() {
      this.searchForm.pageNum = 1;
      this.searchList();
    },
    // 关闭弹窗
    close() {
      this.$emit('update:show', false);
      this.searchForm.pageNum = 1;
      this.searchForm.pageSize = 10;
    },
    // 选中一行
    select(row) {
      if (!this.multiple) {
        if (!row) return this.$message.error('请选择一行');
        this.selected = [row];
        this.$emit('select', row);
      }
    },
  },
}
</script>
